
\begin{abstract}

Domain-Specific Languages (DSLs) are
%a popular means of providing domain-specific software functionality. DSLs are
often classified into external and internal DSLs. An external
DSL is a stand-alone language with its own parser.
%Examples are XML and JSON for representing data.
An internal DSL is an extension of an existing programming language, the
host language, offering the user of the DSL domain-specific constructs
as well as the constructs of the host language, thus providing a richer
language than the DSL itself.
%In this paper we investigate the various ways, in which one can define
%external and internal DSLs in the context of the Scala programming
%language. We present a systematic overview of advantages and disadvantages
%of each option, based on practical experience in the context of building
%modeling and verification tools in Scala.
In this paper we report on experiences implementing external as well as internal
formal modeling DSLs with the Scala programming language, known in
particular for its support for defining DSLs. 
The modeling languages include monitoring logics, a testing language,
and a general purpose SysML inspired modeling language.
We present a systematic
overview of advantages and disadvantages of each option.

\end{abstract}

\keywords{External and internal Domain-specific language, DSL, Scala,
modeling, programming, language design, evaluation.}
